import { ValidationError } from "jsonschema";
import { HttpError } from "./HttpError";
import { HttpBadRequestError } from "./GeneratedErrors";
export * from './HttpError';
export * from './GeneratedErrors';
export declare class HttpTransportConfigurationError extends HttpError {
    constructor(m?: string);
}
export declare class HttpRequiredQueryParamMissingError extends HttpBadRequestError {
    constructor(queryParamName: string);
}
export declare class HttpRequiredPathParamMissingError extends HttpBadRequestError {
    constructor(pathParamName: string);
}
export declare class HttpRequiredHeaderParamMissingError extends HttpBadRequestError {
    constructor(headerParamName: string);
}
export declare class HttpRequiredBodyParamMissingError extends HttpBadRequestError {
    constructor();
}
export declare class HttpRequiredTransportParamMissingError extends HttpBadRequestError {
    constructor(queryParamName: string);
}
export declare class HttpQueryParamInvalidTypeError extends HttpBadRequestError {
    constructor(queryParamName: string, expectedType: string);
}
export declare class HttpRegexParamInvalidTypeError extends HttpBadRequestError {
    constructor(paramName: string, regex: string);
}
export declare class HttpNumberParamOutOfBoundsError extends HttpBadRequestError {
    constructor(paramName: string, minVal?: number, maxVal?: number);
}
export declare class HttpEnumParamInvalidValueError extends HttpBadRequestError {
    constructor(paramName: string, values: any[]);
}
export declare class HttpConstParamInvalidValueError extends HttpBadRequestError {
    constructor(paramName: string, value: any);
}
export declare class HttpParamInvalidError extends HttpBadRequestError {
    constructor(paramName: string);
}
export declare class HttpBodyParamInvalidTypeError extends HttpBadRequestError {
    constructor(expectedType: string);
}
export declare class HttpBodyParamValidationError extends HttpBadRequestError {
    constructor(validationError: ValidationError);
}
