"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpBodyParamValidationError = exports.HttpBodyParamInvalidTypeError = exports.HttpParamInvalidError = exports.HttpConstParamInvalidValueError = exports.HttpEnumParamInvalidValueError = exports.HttpNumberParamOutOfBoundsError = exports.HttpRegexParamInvalidTypeError = exports.HttpQueryParamInvalidTypeError = exports.HttpRequiredTransportParamMissingError = exports.HttpRequiredBodyParamMissingError = exports.HttpRequiredHeaderParamMissingError = exports.HttpRequiredPathParamMissingError = exports.HttpRequiredQueryParamMissingError = exports.HttpTransportConfigurationError = void 0;
const HttpError_1 = require("./HttpError");
const GeneratedErrors_1 = require("./GeneratedErrors");
__exportStar(require("./HttpError"), exports);
__exportStar(require("./GeneratedErrors"), exports);
class HttpTransportConfigurationError extends HttpError_1.HttpError {
    constructor(m = 'Internal Server Error') {
        super(m, 500, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpTransportConfigurationError.prototype);
    }
}
exports.HttpTransportConfigurationError = HttpTransportConfigurationError;
class HttpRequiredQueryParamMissingError extends GeneratedErrors_1.HttpBadRequestError {
    constructor(queryParamName) {
        super(`Missing required query parameter '${queryParamName}'`);
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpRequiredQueryParamMissingError.prototype);
    }
}
exports.HttpRequiredQueryParamMissingError = HttpRequiredQueryParamMissingError;
class HttpRequiredPathParamMissingError extends GeneratedErrors_1.HttpBadRequestError {
    constructor(pathParamName) {
        super(`Missing required path parameter '${pathParamName}'`);
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpRequiredPathParamMissingError.prototype);
    }
}
exports.HttpRequiredPathParamMissingError = HttpRequiredPathParamMissingError;
class HttpRequiredHeaderParamMissingError extends GeneratedErrors_1.HttpBadRequestError {
    constructor(headerParamName) {
        super(`Missing required header parameter '${headerParamName}'`);
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpRequiredHeaderParamMissingError.prototype);
    }
}
exports.HttpRequiredHeaderParamMissingError = HttpRequiredHeaderParamMissingError;
class HttpRequiredBodyParamMissingError extends GeneratedErrors_1.HttpBadRequestError {
    constructor() {
        super(`Missing request body`);
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpRequiredBodyParamMissingError.prototype);
    }
}
exports.HttpRequiredBodyParamMissingError = HttpRequiredBodyParamMissingError;
class HttpRequiredTransportParamMissingError extends GeneratedErrors_1.HttpBadRequestError {
    constructor(queryParamName) {
        super(`Missing required transport parameter '${queryParamName}'`);
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpRequiredTransportParamMissingError.prototype);
    }
}
exports.HttpRequiredTransportParamMissingError = HttpRequiredTransportParamMissingError;
class HttpQueryParamInvalidTypeError extends GeneratedErrors_1.HttpBadRequestError {
    constructor(queryParamName, expectedType) {
        super(`Invalid value for query parameter '${queryParamName}'. Must be a valid ${expectedType}.`);
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpQueryParamInvalidTypeError.prototype);
    }
}
exports.HttpQueryParamInvalidTypeError = HttpQueryParamInvalidTypeError;
class HttpRegexParamInvalidTypeError extends GeneratedErrors_1.HttpBadRequestError {
    constructor(paramName, regex) {
        super(`Invalid value for parameter '${paramName}'. Must match regular expression: ${regex}.`);
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpRegexParamInvalidTypeError.prototype);
    }
}
exports.HttpRegexParamInvalidTypeError = HttpRegexParamInvalidTypeError;
class HttpNumberParamOutOfBoundsError extends GeneratedErrors_1.HttpBadRequestError {
    constructor(paramName, minVal = Number.NEGATIVE_INFINITY, maxVal = Number.POSITIVE_INFINITY) {
        super(`Invalid value for parameter '${paramName}'. Value must be within [${minVal}, ${maxVal}] (inclusive)`);
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpNumberParamOutOfBoundsError.prototype);
    }
}
exports.HttpNumberParamOutOfBoundsError = HttpNumberParamOutOfBoundsError;
class HttpEnumParamInvalidValueError extends GeneratedErrors_1.HttpBadRequestError {
    constructor(paramName, values) {
        super(`Invalid value for parameter '${paramName}'. Value must be one of [${values.join(', ')}]`);
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpEnumParamInvalidValueError.prototype);
    }
}
exports.HttpEnumParamInvalidValueError = HttpEnumParamInvalidValueError;
class HttpConstParamInvalidValueError extends GeneratedErrors_1.HttpBadRequestError {
    constructor(paramName, value) {
        super(`Invalid value for const parameter '${paramName}'. Value must be '${value}'`);
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpConstParamInvalidValueError.prototype);
    }
}
exports.HttpConstParamInvalidValueError = HttpConstParamInvalidValueError;
class HttpParamInvalidError extends GeneratedErrors_1.HttpBadRequestError {
    constructor(paramName) {
        super(`Invalid value for parameter '${paramName}'.`);
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpParamInvalidError.prototype);
    }
}
exports.HttpParamInvalidError = HttpParamInvalidError;
class HttpBodyParamInvalidTypeError extends GeneratedErrors_1.HttpBadRequestError {
    constructor(expectedType) {
        super(`Invalid value for body. Must be a valid ${expectedType}.`);
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpBodyParamInvalidTypeError.prototype);
    }
}
exports.HttpBodyParamInvalidTypeError = HttpBodyParamInvalidTypeError;
class HttpBodyParamValidationError extends GeneratedErrors_1.HttpBadRequestError {
    constructor(validationError) {
        super(`Error request validating body: ` + validationError.toString());
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpBodyParamValidationError.prototype);
    }
}
exports.HttpBodyParamValidationError = HttpBodyParamValidationError;
//# sourceMappingURL=Errors.js.map