/**
 * AUTO-GENERATED FILE
 * This file is automatically generated. Do not edit it directly.
 * Instead, run `yarn generate-error-classes` after editing `/source-generators/http-errors/errors.yaml`.
 */
import { HttpError } from "./HttpError";
/**
 * HTTP 400: Bad Request
 * @description The server cannot or will not process the request due to an apparent client error (e.g., malformed request syntax, size too large, invalid request message framing, or deceptive request routing).
 * @name Bad Request
 */
export declare class HttpBadRequestError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 401: Unauthorized
 * @description Similar to 403 Forbidden, but specifically for use when authentication is required and has failed or has not yet been provided. The response must include a WWW-Authenticate header field containing a challenge applicable to the requested resource.
 * @name Unauthorized
 * @see https://tools.ietf.org/html/rfc7235
 */
export declare class HttpUnauthorizedError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 402: Payment Required
 * @description Reserved for future use
 * @name Payment Required
 */
export declare class HttpPaymentRequiredError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 403: Forbidden
 * @description The request contained valid data and was understood by the server, but the server is refusing action. This may be due to the user not having the necessary permissions for a resource or needing an account of some sort, or attempting a prohibited action (e.g. creating a duplicate record where only one is allowed). This code is also typically used if the request provided authentication via the WWW-Authenticate header field, but the server did not accept that authentication. The request should not be repeated.
 * @name Forbidden
 */
export declare class HttpForbiddenError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 404: Not Found
 * @description The requested resource could not be found but may be available in the future. Subsequent requests by the client are permissible.
 * @name Not Found
 */
export declare class HttpNotFoundError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 405: Method Not Allowed
 * @description A request method is not supported for the requested resource; for example, a GET request on a form that requires data to be presented via POST, or a PUT request on a read-only resource.
 * @name Method Not Allowed
 */
export declare class HttpMethodNotAllowedError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 406: Not Acceptable
 * @description The requested resource is capable of generating only content not acceptable according to the Accept headers sent in the request
 * @name Not Acceptable
 */
export declare class HttpNotAcceptableError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 407: Proxy Authentication Required
 * @description The client must first authenticate itself with the proxy.
 * @name Proxy Authentication Required
 * @see https://tools.ietf.org/html/rfc7235
 */
export declare class HttpProxyAuthenticationRequiredError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 408: Request Timeout
 * @description The server timed out waiting for the request. According to HTTP specifications: 'The client did not produce a request within the time that the server was prepared to wait. The client MAY repeat the request without modifications at any later time.'
 * @name Request Timeout
 */
export declare class HttpRequestTimeoutError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 409: Conflict
 * @description Indicates that the request could not be processed because of conflict in the current state of the resource, such as an edit conflict between multiple simultaneous updates.
 * @name Conflict
 */
export declare class HttpConflictError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 410: Gone
 * @description Indicates that the resource requested is no longer available and will not be available again. This should be used when a resource has been intentionally removed and the resource should be purged. Upon receiving a 410 status code, the client should not request the resource in the future.
 * @name Gone
 */
export declare class HttpGoneError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 411: Length Required
 * @description The request did not specify the length of its content, which is required by the requested resource.
 * @name Length Required
 */
export declare class HttpLengthRequiredError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 412: Precondition Failed
 * @description The server does not meet one of the preconditions that the requester put on the request header fields
 * @name Precondition Failed
 * @see https://tools.ietf.org/html/rfc7232
 */
export declare class HttpPreconditionFailedError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 413: Request Entity Too Large
 * @description The request is larger than the server is willing or able to process. Previously called "Request Entity Too Large"
 * @name Request Entity Too Large
 * @see https://tools.ietf.org/html/rfc7231
 */
export declare class HttpRequestEntityTooLargeError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 414: Request-URI Too Long
 * @description The URI provided was too long for the server to process.
 * @name Request-URI Too Long
 * @see https://tools.ietf.org/html/rfc7231
 */
export declare class HttpRequestURITooLongError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 415: Unsupported Media Type
 * @description The request entity has a media type which the server or resource does not support.
 * @name Unsupported Media Type
 * @see https://tools.ietf.org/html/rfc7231
 */
export declare class HttpUnsupportedMediaTypeError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 416: Requested Range Not Satisfiable
 * @description The client has asked for a portion of the file (byte serving), but the server cannot supply that portion
 * @name Requested Range Not Satisfiable
 * @see https://tools.ietf.org/html/rfc7233
 */
export declare class HttpRequestedRangeNotSatisfiableError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 417: Expectation Failed
 * @description The server cannot meet the requirements of the Expect request-header field.
 * @name Expectation Failed
 */
export declare class HttpExpectationFailedError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 418: I'm A Teapot
 * @description Indicates that the server cannot brew coffee, because it is a teapot.
 * @name I'm A Teapot
 * @see https://tools.ietf.org/html/rfc2324
 */
export declare class HttpImATeapotError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 421: Misdirected Request
 * @description The request was directed at a server that is not able to produce a response
 * @name Misdirected Request
 * @see https://tools.ietf.org/html/rfc7540
 */
export declare class HttpMisdirectedRequestError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 425: Too Early
 * @description Indicates that the server is unwilling to risk processing a request that might be replayed.
 * @name Too Early
 * @see https://tools.ietf.org/html/rfc8470
 */
export declare class HttpTooEarlyError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 426: Upgrade Required
 * @description The client should switch to a different protocol such as TLS/1.0, given in the Upgrade header field.
 * @name Upgrade Required
 */
export declare class HttpUpgradeRequiredError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 428: Precondition Required
 * @description The origin server requires the request to be conditional. Intended to prevent the 'lost update' problem, where a client GETs a resource's state, modifies it, and PUTs it back to the server, when meanwhile a third party has modified the state on the server, leading to a conflict.
 * @name Precondition Required
 * @see https://tools.ietf.org/html/rfc6585
 */
export declare class HttpPreconditionRequiredError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 429: Too Many Requests
 * @description The user has sent too many requests in a given amount of time. Intended for use with rate-limiting schemes.
 * @name Too Many Requests
 * @see https://tools.ietf.org/html/rfc6585
 */
export declare class HttpTooManyRequestsError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 431: Request Header Fields Too Large
 * @description The server is unwilling to process the request because either an individual header field, or all the header fields collectively, are too large.
 * @name Request Header Fields Too Large
 * @see https://tools.ietf.org/html/rfc6585
 */
export declare class HttpRequestHeaderFieldsTooLargeError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 451: Unavailable For Legal Reasons
 * @description A server operator has received a legal demand to deny access to a resource or to a set of resources that includes the requested resource.
 * @name Unavailable For Legal Reasons
 * @see https://tools.ietf.org/html/rfc7725
 */
export declare class HttpUnavailableForLegalReasonsError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 500: Internal Server Error
 * @description A generic error message, given when an unexpected condition was encountered and no more specific message is suitable
 * @name Internal Server Error
 */
export declare class HttpInternalServerErrorError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 501: Not Implemented
 * @description The server either does not recognize the request method, or it lacks the ability to fulfil the request
 * @name Not Implemented
 */
export declare class HttpNotImplementedError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 502: Bad Gateway
 * @description The server was acting as a gateway or proxy and received an invalid response from the upstream server
 * @name Bad Gateway
 */
export declare class HttpBadGatewayError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 503: Service Unavailable
 * @description The server cannot handle the request (because it is overloaded or down for maintenance)
 * @name Service Unavailable
 */
export declare class HttpServiceUnavailableError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 504: Gateway Timeout
 * @description The server was acting as a gateway or proxy and did not receive a timely response from the upstream server
 * @name Gateway Timeout
 */
export declare class HttpGatewayTimeoutError extends HttpError {
    constructor(m?: string);
}
/**
 * HTTP 505: HTTP Version Not Supported
 * @description The server does not support the HTTP protocol version used in the request
 * @name HTTP Version Not Supported
 */
export declare class HttpVersionNotSupportedError extends HttpError {
    constructor(m?: string);
}
