"use strict";
/**
 * AUTO-GENERATED FILE
 * This file is automatically generated. Do not edit it directly.
 * Instead, run `yarn generate-error-classes` after editing `/source-generators/http-errors/errors.yaml`.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpVersionNotSupportedError = exports.HttpGatewayTimeoutError = exports.HttpServiceUnavailableError = exports.HttpBadGatewayError = exports.HttpNotImplementedError = exports.HttpInternalServerErrorError = exports.HttpUnavailableForLegalReasonsError = exports.HttpRequestHeaderFieldsTooLargeError = exports.HttpTooManyRequestsError = exports.HttpPreconditionRequiredError = exports.HttpUpgradeRequiredError = exports.HttpTooEarlyError = exports.HttpMisdirectedRequestError = exports.HttpImATeapotError = exports.HttpExpectationFailedError = exports.HttpRequestedRangeNotSatisfiableError = exports.HttpUnsupportedMediaTypeError = exports.HttpRequestURITooLongError = exports.HttpRequestEntityTooLargeError = exports.HttpPreconditionFailedError = exports.HttpLengthRequiredError = exports.HttpGoneError = exports.HttpConflictError = exports.HttpRequestTimeoutError = exports.HttpProxyAuthenticationRequiredError = exports.HttpNotAcceptableError = exports.HttpMethodNotAllowedError = exports.HttpNotFoundError = exports.HttpForbiddenError = exports.HttpPaymentRequiredError = exports.HttpUnauthorizedError = exports.HttpBadRequestError = void 0;
const HttpError_1 = require("./HttpError");
/**
 * HTTP 400: Bad Request
 * @description The server cannot or will not process the request due to an apparent client error (e.g., malformed request syntax, size too large, invalid request message framing, or deceptive request routing).
 * @name Bad Request
 */
class HttpBadRequestError extends HttpError_1.HttpError {
    constructor(m = 'Bad Request') {
        super(m, 400, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpBadRequestError.prototype);
    }
}
exports.HttpBadRequestError = HttpBadRequestError;
/**
 * HTTP 401: Unauthorized
 * @description Similar to 403 Forbidden, but specifically for use when authentication is required and has failed or has not yet been provided. The response must include a WWW-Authenticate header field containing a challenge applicable to the requested resource.
 * @name Unauthorized
 * @see https://tools.ietf.org/html/rfc7235
 */
class HttpUnauthorizedError extends HttpError_1.HttpError {
    constructor(m = 'Unauthorized') {
        super(m, 401, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpUnauthorizedError.prototype);
    }
}
exports.HttpUnauthorizedError = HttpUnauthorizedError;
/**
 * HTTP 402: Payment Required
 * @description Reserved for future use
 * @name Payment Required
 */
class HttpPaymentRequiredError extends HttpError_1.HttpError {
    constructor(m = 'Payment Required') {
        super(m, 402, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpPaymentRequiredError.prototype);
    }
}
exports.HttpPaymentRequiredError = HttpPaymentRequiredError;
/**
 * HTTP 403: Forbidden
 * @description The request contained valid data and was understood by the server, but the server is refusing action. This may be due to the user not having the necessary permissions for a resource or needing an account of some sort, or attempting a prohibited action (e.g. creating a duplicate record where only one is allowed). This code is also typically used if the request provided authentication via the WWW-Authenticate header field, but the server did not accept that authentication. The request should not be repeated.
 * @name Forbidden
 */
class HttpForbiddenError extends HttpError_1.HttpError {
    constructor(m = 'Forbidden') {
        super(m, 403, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpForbiddenError.prototype);
    }
}
exports.HttpForbiddenError = HttpForbiddenError;
/**
 * HTTP 404: Not Found
 * @description The requested resource could not be found but may be available in the future. Subsequent requests by the client are permissible.
 * @name Not Found
 */
class HttpNotFoundError extends HttpError_1.HttpError {
    constructor(m = 'Not Found') {
        super(m, 404, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpNotFoundError.prototype);
    }
}
exports.HttpNotFoundError = HttpNotFoundError;
/**
 * HTTP 405: Method Not Allowed
 * @description A request method is not supported for the requested resource; for example, a GET request on a form that requires data to be presented via POST, or a PUT request on a read-only resource.
 * @name Method Not Allowed
 */
class HttpMethodNotAllowedError extends HttpError_1.HttpError {
    constructor(m = 'Method Not Allowed') {
        super(m, 405, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpMethodNotAllowedError.prototype);
    }
}
exports.HttpMethodNotAllowedError = HttpMethodNotAllowedError;
/**
 * HTTP 406: Not Acceptable
 * @description The requested resource is capable of generating only content not acceptable according to the Accept headers sent in the request
 * @name Not Acceptable
 */
class HttpNotAcceptableError extends HttpError_1.HttpError {
    constructor(m = 'Not Acceptable') {
        super(m, 406, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpNotAcceptableError.prototype);
    }
}
exports.HttpNotAcceptableError = HttpNotAcceptableError;
/**
 * HTTP 407: Proxy Authentication Required
 * @description The client must first authenticate itself with the proxy.
 * @name Proxy Authentication Required
 * @see https://tools.ietf.org/html/rfc7235
 */
class HttpProxyAuthenticationRequiredError extends HttpError_1.HttpError {
    constructor(m = 'Proxy Authentication Required') {
        super(m, 407, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpProxyAuthenticationRequiredError.prototype);
    }
}
exports.HttpProxyAuthenticationRequiredError = HttpProxyAuthenticationRequiredError;
/**
 * HTTP 408: Request Timeout
 * @description The server timed out waiting for the request. According to HTTP specifications: 'The client did not produce a request within the time that the server was prepared to wait. The client MAY repeat the request without modifications at any later time.'
 * @name Request Timeout
 */
class HttpRequestTimeoutError extends HttpError_1.HttpError {
    constructor(m = 'Request Timeout') {
        super(m, 408, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpRequestTimeoutError.prototype);
    }
}
exports.HttpRequestTimeoutError = HttpRequestTimeoutError;
/**
 * HTTP 409: Conflict
 * @description Indicates that the request could not be processed because of conflict in the current state of the resource, such as an edit conflict between multiple simultaneous updates.
 * @name Conflict
 */
class HttpConflictError extends HttpError_1.HttpError {
    constructor(m = 'Conflict') {
        super(m, 409, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpConflictError.prototype);
    }
}
exports.HttpConflictError = HttpConflictError;
/**
 * HTTP 410: Gone
 * @description Indicates that the resource requested is no longer available and will not be available again. This should be used when a resource has been intentionally removed and the resource should be purged. Upon receiving a 410 status code, the client should not request the resource in the future.
 * @name Gone
 */
class HttpGoneError extends HttpError_1.HttpError {
    constructor(m = 'Gone') {
        super(m, 410, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpGoneError.prototype);
    }
}
exports.HttpGoneError = HttpGoneError;
/**
 * HTTP 411: Length Required
 * @description The request did not specify the length of its content, which is required by the requested resource.
 * @name Length Required
 */
class HttpLengthRequiredError extends HttpError_1.HttpError {
    constructor(m = 'Length Required') {
        super(m, 411, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpLengthRequiredError.prototype);
    }
}
exports.HttpLengthRequiredError = HttpLengthRequiredError;
/**
 * HTTP 412: Precondition Failed
 * @description The server does not meet one of the preconditions that the requester put on the request header fields
 * @name Precondition Failed
 * @see https://tools.ietf.org/html/rfc7232
 */
class HttpPreconditionFailedError extends HttpError_1.HttpError {
    constructor(m = 'Precondition Failed') {
        super(m, 412, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpPreconditionFailedError.prototype);
    }
}
exports.HttpPreconditionFailedError = HttpPreconditionFailedError;
/**
 * HTTP 413: Request Entity Too Large
 * @description The request is larger than the server is willing or able to process. Previously called "Request Entity Too Large"
 * @name Request Entity Too Large
 * @see https://tools.ietf.org/html/rfc7231
 */
class HttpRequestEntityTooLargeError extends HttpError_1.HttpError {
    constructor(m = 'Request Entity Too Large') {
        super(m, 413, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpRequestEntityTooLargeError.prototype);
    }
}
exports.HttpRequestEntityTooLargeError = HttpRequestEntityTooLargeError;
/**
 * HTTP 414: Request-URI Too Long
 * @description The URI provided was too long for the server to process.
 * @name Request-URI Too Long
 * @see https://tools.ietf.org/html/rfc7231
 */
class HttpRequestURITooLongError extends HttpError_1.HttpError {
    constructor(m = 'Request-URI Too Long') {
        super(m, 414, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpRequestURITooLongError.prototype);
    }
}
exports.HttpRequestURITooLongError = HttpRequestURITooLongError;
/**
 * HTTP 415: Unsupported Media Type
 * @description The request entity has a media type which the server or resource does not support.
 * @name Unsupported Media Type
 * @see https://tools.ietf.org/html/rfc7231
 */
class HttpUnsupportedMediaTypeError extends HttpError_1.HttpError {
    constructor(m = 'Unsupported Media Type') {
        super(m, 415, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpUnsupportedMediaTypeError.prototype);
    }
}
exports.HttpUnsupportedMediaTypeError = HttpUnsupportedMediaTypeError;
/**
 * HTTP 416: Requested Range Not Satisfiable
 * @description The client has asked for a portion of the file (byte serving), but the server cannot supply that portion
 * @name Requested Range Not Satisfiable
 * @see https://tools.ietf.org/html/rfc7233
 */
class HttpRequestedRangeNotSatisfiableError extends HttpError_1.HttpError {
    constructor(m = 'Requested Range Not Satisfiable') {
        super(m, 416, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpRequestedRangeNotSatisfiableError.prototype);
    }
}
exports.HttpRequestedRangeNotSatisfiableError = HttpRequestedRangeNotSatisfiableError;
/**
 * HTTP 417: Expectation Failed
 * @description The server cannot meet the requirements of the Expect request-header field.
 * @name Expectation Failed
 */
class HttpExpectationFailedError extends HttpError_1.HttpError {
    constructor(m = 'Expectation Failed') {
        super(m, 417, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpExpectationFailedError.prototype);
    }
}
exports.HttpExpectationFailedError = HttpExpectationFailedError;
/**
 * HTTP 418: I'm A Teapot
 * @description Indicates that the server cannot brew coffee, because it is a teapot.
 * @name I'm A Teapot
 * @see https://tools.ietf.org/html/rfc2324
 */
class HttpImATeapotError extends HttpError_1.HttpError {
    constructor(m = 'I\'m A Teapot') {
        super(m, 418, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpImATeapotError.prototype);
    }
}
exports.HttpImATeapotError = HttpImATeapotError;
/**
 * HTTP 421: Misdirected Request
 * @description The request was directed at a server that is not able to produce a response
 * @name Misdirected Request
 * @see https://tools.ietf.org/html/rfc7540
 */
class HttpMisdirectedRequestError extends HttpError_1.HttpError {
    constructor(m = 'Misdirected Request') {
        super(m, 421, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpMisdirectedRequestError.prototype);
    }
}
exports.HttpMisdirectedRequestError = HttpMisdirectedRequestError;
/**
 * HTTP 425: Too Early
 * @description Indicates that the server is unwilling to risk processing a request that might be replayed.
 * @name Too Early
 * @see https://tools.ietf.org/html/rfc8470
 */
class HttpTooEarlyError extends HttpError_1.HttpError {
    constructor(m = 'Too Early') {
        super(m, 425, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpTooEarlyError.prototype);
    }
}
exports.HttpTooEarlyError = HttpTooEarlyError;
/**
 * HTTP 426: Upgrade Required
 * @description The client should switch to a different protocol such as TLS/1.0, given in the Upgrade header field.
 * @name Upgrade Required
 */
class HttpUpgradeRequiredError extends HttpError_1.HttpError {
    constructor(m = 'Upgrade Required') {
        super(m, 426, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpUpgradeRequiredError.prototype);
    }
}
exports.HttpUpgradeRequiredError = HttpUpgradeRequiredError;
/**
 * HTTP 428: Precondition Required
 * @description The origin server requires the request to be conditional. Intended to prevent the 'lost update' problem, where a client GETs a resource's state, modifies it, and PUTs it back to the server, when meanwhile a third party has modified the state on the server, leading to a conflict.
 * @name Precondition Required
 * @see https://tools.ietf.org/html/rfc6585
 */
class HttpPreconditionRequiredError extends HttpError_1.HttpError {
    constructor(m = 'Precondition Required') {
        super(m, 428, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpPreconditionRequiredError.prototype);
    }
}
exports.HttpPreconditionRequiredError = HttpPreconditionRequiredError;
/**
 * HTTP 429: Too Many Requests
 * @description The user has sent too many requests in a given amount of time. Intended for use with rate-limiting schemes.
 * @name Too Many Requests
 * @see https://tools.ietf.org/html/rfc6585
 */
class HttpTooManyRequestsError extends HttpError_1.HttpError {
    constructor(m = 'Too Many Requests') {
        super(m, 429, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpTooManyRequestsError.prototype);
    }
}
exports.HttpTooManyRequestsError = HttpTooManyRequestsError;
/**
 * HTTP 431: Request Header Fields Too Large
 * @description The server is unwilling to process the request because either an individual header field, or all the header fields collectively, are too large.
 * @name Request Header Fields Too Large
 * @see https://tools.ietf.org/html/rfc6585
 */
class HttpRequestHeaderFieldsTooLargeError extends HttpError_1.HttpError {
    constructor(m = 'Request Header Fields Too Large') {
        super(m, 431, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpRequestHeaderFieldsTooLargeError.prototype);
    }
}
exports.HttpRequestHeaderFieldsTooLargeError = HttpRequestHeaderFieldsTooLargeError;
/**
 * HTTP 451: Unavailable For Legal Reasons
 * @description A server operator has received a legal demand to deny access to a resource or to a set of resources that includes the requested resource.
 * @name Unavailable For Legal Reasons
 * @see https://tools.ietf.org/html/rfc7725
 */
class HttpUnavailableForLegalReasonsError extends HttpError_1.HttpError {
    constructor(m = 'Unavailable For Legal Reasons') {
        super(m, 451, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpUnavailableForLegalReasonsError.prototype);
    }
}
exports.HttpUnavailableForLegalReasonsError = HttpUnavailableForLegalReasonsError;
/**
 * HTTP 500: Internal Server Error
 * @description A generic error message, given when an unexpected condition was encountered and no more specific message is suitable
 * @name Internal Server Error
 */
class HttpInternalServerErrorError extends HttpError_1.HttpError {
    constructor(m = 'Internal Server Error') {
        super(m, 500, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpInternalServerErrorError.prototype);
    }
}
exports.HttpInternalServerErrorError = HttpInternalServerErrorError;
/**
 * HTTP 501: Not Implemented
 * @description The server either does not recognize the request method, or it lacks the ability to fulfil the request
 * @name Not Implemented
 */
class HttpNotImplementedError extends HttpError_1.HttpError {
    constructor(m = 'Not Implemented') {
        super(m, 501, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpNotImplementedError.prototype);
    }
}
exports.HttpNotImplementedError = HttpNotImplementedError;
/**
 * HTTP 502: Bad Gateway
 * @description The server was acting as a gateway or proxy and received an invalid response from the upstream server
 * @name Bad Gateway
 */
class HttpBadGatewayError extends HttpError_1.HttpError {
    constructor(m = 'Bad Gateway') {
        super(m, 502, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpBadGatewayError.prototype);
    }
}
exports.HttpBadGatewayError = HttpBadGatewayError;
/**
 * HTTP 503: Service Unavailable
 * @description The server cannot handle the request (because it is overloaded or down for maintenance)
 * @name Service Unavailable
 */
class HttpServiceUnavailableError extends HttpError_1.HttpError {
    constructor(m = 'Service Unavailable') {
        super(m, 503, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpServiceUnavailableError.prototype);
    }
}
exports.HttpServiceUnavailableError = HttpServiceUnavailableError;
/**
 * HTTP 504: Gateway Timeout
 * @description The server was acting as a gateway or proxy and did not receive a timely response from the upstream server
 * @name Gateway Timeout
 */
class HttpGatewayTimeoutError extends HttpError_1.HttpError {
    constructor(m = 'Gateway Timeout') {
        super(m, 504, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpGatewayTimeoutError.prototype);
    }
}
exports.HttpGatewayTimeoutError = HttpGatewayTimeoutError;
/**
 * HTTP 505: HTTP Version Not Supported
 * @description The server does not support the HTTP protocol version used in the request
 * @name HTTP Version Not Supported
 */
class HttpVersionNotSupportedError extends HttpError_1.HttpError {
    constructor(m = 'HTTP Version Not Supported') {
        super(m, 505, {});
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpVersionNotSupportedError.prototype);
    }
}
exports.HttpVersionNotSupportedError = HttpVersionNotSupportedError;
//# sourceMappingURL=GeneratedErrors.js.map