import { ManagedApi as BaseManagedApi, IApiHandlerInstance, ApiMethod, ApiHeadersDict, ApiParamsDict, IApiInvocationResult, IApiBodyContents } from '..';
import * as p2r from 'path-to-regexp';
export interface ITestManagedApiContext {
}
export interface IApiCallInterface {
    invokeApiCall(method: ApiMethod, route: string, params: ITestApiInvocationParams): Promise<IApiInvocationResult>;
    getHandlerInstance(method: ApiMethod, route: string): {
        matchResult: p2r.Match<ApiParamsDict>;
        instance: IApiHandlerInstance<ITestManagedApiContext>;
    };
}
export interface ITestApiInvocationParams {
    queryParams: ApiParamsDict;
    headers: ApiHeadersDict;
    bodyContents?: Partial<IApiBodyContents>;
    transportParams: ITestManagedApiContext;
}
export declare class TestManagedApi extends BaseManagedApi<ITestManagedApiContext> implements IApiCallInterface {
    private handlers;
    init(): IApiCallInterface;
    invokeApiCall(method: ApiMethod, route: string, params: ITestApiInvocationParams): Promise<IApiInvocationResult>;
    private underfinedOrNull;
    getHandlerInstance(method: ApiMethod, route: string): {
        matchResult: p2r.MatchResult<ApiParamsDict>;
        instance: IApiHandlerInstance<ITestManagedApiContext>;
    } | undefined;
    private getResponse;
    setHeader(name: string, value: string): void;
}
