import { IParseOptions } from '../command/ProgramOptions';
import { ITransformerArguments } from '../transformer';
import { IParseApiResult } from '../command/CliCommand';
import { ParsedCommandLine } from 'typescript';
import { IHandlerTreeNodeRoot } from '../transformer/HandlerTree';
import { IProgramInfo } from '../command/IProgramInfo';
export declare class ApiParser {
    private static readonly DEFAULT_TSCONFIG;
    private tree;
    parseApi(options: IParseOptions, transformerArgs?: ITransformerArguments): Promise<IParseApiResult>;
    private onTreeExtracted;
    loadTsConfig(tsConfig: string | undefined, resolvedRootDir: string): {
        tsConfig: ParsedCommandLine;
        path: string;
    };
    loadApiInfo(apiInfoPath: string): IProgramInfo | undefined;
    getTree(): IHandlerTreeNodeRoot | null;
}
