"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.asyncGlob = void 0;
const glob = require("glob");
function asyncGlob(path, options, g = glob) {
    return new Promise((resolve, reject) => {
        try {
            g(path, options, (err, matches) => {
                if (err) {
                    reject(err);
                }
                else {
                    resolve(matches);
                }
            });
        }
        catch (e) {
            reject(e);
        }
    });
}
exports.asyncGlob = asyncGlob;
//# sourceMappingURL=AsyncGlob.js.map