"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CompilationError = void 0;
class CompilationError extends Error {
    constructor(m, node) {
        super(m);
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, CompilationError.prototype);
        this.stack = `API Compilation Error: ${m}
    at ${node.getText()} (${node.getSourceFile().fileName}:${node.pos})`;
    }
}
exports.CompilationError = CompilationError;
//# sourceMappingURL=CompilationError.js.map