import * as ts from 'typescript';
import { ITransformerArguments } from "../transformer";
export type TransformerType = (program: ts.Program, args?: ITransformerArguments) => ts.TransformerFactory<ts.SourceFile>;
export declare function getDefaultCompilerOptions(): ts.CompilerOptions;
export declare class TsConfigParserHost implements ts.ParseConfigHost {
    useCaseSensitiveFileNames: boolean;
    readDirectory(rootDir: string, extensions: readonly string[], excludes: readonly string[], includes: readonly string[], depth?: number): readonly string[];
    private pathToGlobIgnore;
    fileExists(path: string): boolean;
    readFile(path: string): string;
    trace?(s: string): void;
}
export declare function parseTsConfig(basePath: string, tsconfigPath: string): ts.ParsedCommandLine;
export declare function compileSourcesFromTsConfigFile(basePath: string, tsconfigPath: string, transformers: TransformerType[]): Promise<{
    [path: string]: ts.TransformationResult<ts.Node>;
}>;
export declare function compileSourcesDir(path: string, options: ts.CompilerOptions, transformers: TransformerType[]): Promise<{
    [path: string]: ts.TransformationResult<ts.Node>;
}>;
export declare function compileSources(matches: string[], options: ts.CompilerOptions, transformers: TransformerType[]): {
    [path: string]: ts.TransformationResult<ts.Node>;
};
export declare function compileSourceFile(path: string, options: ts.CompilerOptions, transformers: TransformerType[], program?: ts.Program): ts.TransformationResult<ts.SourceFile>;
