"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.promisifyEvent = void 0;
function promisifyEvent(obj, event, args) {
    return new Promise((resolve, reject) => {
        let timeout = args?.timeout ? setTimeout(() => {
            timeout = null;
            reject(new Error(`Timed out waiting ${args.timeout}ms for event '${event}'`));
        }, args.timeout) : null;
        obj.on(event, function () {
            if (timeout) {
                clearTimeout(timeout);
            }
            resolve(Array.from(arguments));
        });
    });
}
exports.promisifyEvent = promisifyEvent;
//# sourceMappingURL=PromiseEvent.js.map