/// <reference types="node" />
import * as stream from 'stream';
import { Func1, Func } from './Func';
export declare enum StreamCoercionMode {
    None = 0,
    InheritsStream = 1,
    DuckPipe = 2,
    Any = 7
}
export declare abstract class StreamCoercer {
    private static readonly DefaultOpts;
    private static readonly StreamCoercionModes;
    static IsCoercible(value: any, allowableModes: StreamCoercionMode): StreamCoercionMode;
    static CoerceWith(value: any, mode: StreamCoercionMode): ICoercedStream;
}
export interface ICoercedStreamOptions {
    pipeOptions: ICoercedStreamPipeOptions;
}
export interface ICoercedStreamPipeOptions {
    end?: boolean;
}
export interface ICoercedStream {
    getReadStream(): stream.Readable;
    pipe(outStream: stream.Writable, opts?: ICoercedStreamPipeOptions): void;
    on(event: 'error', handler: Func1<any>): this;
    on(event: 'end', handler: Func): this;
}
