"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PromiseCallbackHelper = void 0;
class PromiseCallbackHelper {
    constructor() {
        this.initPromise = new Promise((resolveInit) => {
            this.p = new Promise((resolve, reject) => {
                this.resolveP = (p) => resolve(p);
                this.rejectP = (p) => {
                    reject(p);
                };
                resolveInit();
            });
        });
    }
    async getCallbackFunc() {
        await this.initPromise;
        return (err, result) => {
            try {
                if (err) {
                    this.rejectP(err);
                }
                else {
                    this.resolveP(result);
                }
            }
            catch (e) {
                console.error('err2', e);
            }
        };
    }
    async execute(func) {
        await this.initPromise;
        try {
            func();
            return await this.p;
        }
        catch (e) {
            return Promise.reject(e);
        }
    }
}
exports.PromiseCallbackHelper = PromiseCallbackHelper;
//# sourceMappingURL=CallbackPromiseHelper.js.map