/// <reference types="node" />
export interface ParsedContentTypeHeader {
    mimeType: ApiMimeType;
    charset: BufferEncoding;
    boundary?: string;
}
export declare function parseApiMimeType(contentTypeHeader: string | undefined, defaultCharset?: BufferEncoding): ParsedContentTypeHeader;
export declare enum ApiMimeType {
    ApplicationJson = "application/json",
    ApplicationJavascript = "application/javascript",
    ApplicationXml = "application/xml",
    ApplicationOctetStream = "application/octet-stream",
    Text = "text/plain",
    TextXml = "text/xml",
    MultipartFormData = "multipart/form-data"
}
