import * as ts from 'typescript';
import { ParsedCommandLine } from 'typescript';
import { IProgramInfo } from './IProgramInfo';
import { IParseOptions } from './ProgramOptions';
import { IHandlerTreeNodeRoot } from '../transformer/HandlerTree';
export interface IParseApiResult {
    compilationResult: {
        [path: string]: ts.TransformationResult<ts.Node>;
    };
    tree: IHandlerTreeNodeRoot;
    programInfo: IProgramInfo;
    tsConfig?: ParsedCommandLine;
    tsConfigPath?: string;
}
export declare abstract class CliCommand {
    private console;
    protected wrapCliError(f: Function): Promise<void>;
    protected handleError(err: any): Promise<void>;
    protected disableConsoleOutput(): void;
    protected enableConsoleOutput(): void;
    protected printExtractionSummary(options: IParseOptions, api: IParseApiResult, tree: IHandlerTreeNodeRoot): string;
}
