"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPackageJsonAuthor = exports.getPackageVersion = void 0;
let packageJson = null;
function loadPackageJson() {
    if (!packageJson) {
        packageJson = require('../../package.json');
    }
    return packageJson;
}
function getPackageVersion() {
    return loadPackageJson().version;
}
exports.getPackageVersion = getPackageVersion;
function getPackageJsonAuthor(pkg) {
    if (typeof pkg.author === 'object') {
        return {
            name: pkg.author.name,
            email: pkg.author.email,
            url: pkg.author.url,
        };
    }
    else if (typeof pkg.author === 'string') {
        return {
            name: getFirstMatch(/^[^(<]+/.exec(pkg.author)),
            email: getFirstMatch(/<([^>]+)>/.exec(pkg.author)),
            url: getFirstMatch(/\(([^)]+)\)/.exec(pkg.author)),
        };
    }
    else {
        return undefined;
    }
}
exports.getPackageJsonAuthor = getPackageJsonAuthor;
function getFirstMatch(arr) {
    if (arr && arr.length > 1) {
        return arr[1].trim();
    }
    else if (arr && arr.length > 0) {
        return arr[0].trim();
    }
}
//# sourceMappingURL=CommandUtil.js.map