import { Command } from 'commander';
import { CliCommand } from './CliCommand';
import { IParseOptions } from './ProgramOptions';
export interface IProgramOptions extends IParseOptions {
    type: string;
    outFile: string;
    silent: boolean;
}
export declare class ExtractCommand extends CliCommand {
    private readonly program;
    private apiParser;
    constructor(program: Command);
    protected runCommand(options: IProgramOptions): Promise<void>;
    private printSummary;
    private printJsonSummary;
    private getSwaggerSummary;
    private getOpenApiV3Summary;
    protected validateProgramOutputType(value: string, defaultValue: string): string;
}
