import { IExtractor } from "./IExtractor";
import { OpenAPIV2 } from 'openapi-types';
import * as yaml from 'js-yaml';
import { IProgramInfo } from "./IProgramInfo";
import { IHandlerTreeNodeRoot } from "../transformer/HandlerTree";
export interface ISwagger2Opts {
    disableTryInferSchemes?: boolean;
    yamlOpts?: yaml.DumpOptions;
}
export declare class Swagger2Extractor implements IExtractor {
    private readonly apiTree;
    private readonly apiInfo;
    private readonly opts;
    static readonly SwaggerVersion = "2.0";
    private static readonly RouteSeperator;
    private static readonly ExcludeMetadataTags;
    private tags;
    private definitions;
    constructor(apiTree: IHandlerTreeNodeRoot, apiInfo: IProgramInfo, opts: ISwagger2Opts);
    protected getDocument(): OpenAPIV2.Document;
    private getDefinitions;
    private tryInferSchemes;
    private validHost;
    private getPaths;
    private swaggerizeRoute;
    private getOperationObject;
    private getOperationResponseDescription;
    private getInlineTypeSchema;
    private getInternalSchemaToOutputSchema;
    private addDefinitions;
    private recordTagObject;
    private getTagObject;
    private getParametersObject;
    toString(): string;
}
export declare class Swagger2JsonExtractor extends Swagger2Extractor {
    toString(): string;
}
