import * as commander from 'commander';
import { CliCommand } from './CliCommand';
import { ClassConstructor1 } from '../Util/ClassConstructors';
export type CommandConstructor<T extends CliCommand = CliCommand> = ClassConstructor1<commander.Command, T>;
export interface IRegistrableCommand {
    registerWithProgram(program: commander.Command): void;
}
export declare class TsApiCommandLine {
    protected program: commander.Command;
    protected commands: Set<CliCommand>;
    constructor();
    addComamnd<T extends CliCommand>(constr: CommandConstructor<T>): T;
    addCommands(commands: CommandConstructor[]): CliCommand[];
    registerCommand(cmd: IRegistrableCommand & CliCommand): void;
    getBuiltinCommands(): CommandConstructor[];
    tryGetPeerLibCommands(): CommandConstructor[];
    parse(argv: string[]): void;
}
