"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApiGetSchemaMethod = exports.ApiDeleteMethod = exports.ApiPostMethod = exports.ApiPutMethod = exports.ApiGetMethod = exports.GetApiMethodDecorator = exports.GetApiDecorator = exports.Api = void 0;
require("reflect-metadata");
const ManagedApiInternal_1 = require("../apiManagement/ManagedApiInternal");
const DecoratorUtil_1 = require("./DecoratorUtil");
const HandlerMethodDecorator_1 = require("../transformer/HandlerMethodDecorator");
const TransformerMetadata_1 = require("../transformer/TransformerMetadata");
const BuiltinArgumentExtractors_1 = require("../transformer/BuiltinArgumentExtractors");
const HandlerCollectionDecorator_1 = require("../transformer/HandlerCollectionDecorator");
const Constants_1 = require("../Constants");
class ApiClassDecorators {
    static Api(constructor) {
        ManagedApiInternal_1.ManagedApiInternal.RegisterApi(constructor);
    }
}
__decorate([
    (0, DecoratorUtil_1.ApiDecorator)(HandlerCollectionDecorator_1.HandlerCollectionDecorator, {
        indexTs: __filename,
        dependencies: [],
        provider: TransformerMetadata_1.BuiltinMetadata.BuiltinComponent,
        arguments: [],
        isCallExpression: false,
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [typeof (_a = typeof T !== "undefined" && T) === "function" ? _a : Object]),
    __metadata("design:returntype", void 0)
], ApiClassDecorators, "Api", null);
exports.Api = ApiClassDecorators.Api;
class ApiMethodDecorators {
    static ApiGetMethod(route, responseCodes, returnType) {
        return (target, propertyKey, descriptor) => {
            ManagedApiInternal_1.ManagedApiInternal.AddApiMetadataToObject(ApiMethodDecorators.wrapApiMethod("GET" /* ApiMethod.GET */, route, propertyKey, descriptor, responseCodes, returnType), target.constructor);
        };
    }
    static ApiGetSchemaMethod(route, outTypeDef) {
        return (target, propertyKey, descriptor) => {
            ManagedApiInternal_1.ManagedApiInternal.AddApiMetadataToObject(ApiMethodDecorators.wrapApiMethodWithHandler("GET" /* ApiMethod.GET */, route, propertyKey, () => {
                if (!outTypeDef) {
                    throw new Error('Could not find typedef');
                }
                if (outTypeDef.type !== 'object') {
                    throw new Error('ApiGetSchemaMethod only supports object types');
                }
                return outTypeDef.schema;
            }, undefined, {
                type: 'external',
                schema: {
                    "$schema": "http://json-schema.org/draft-07/schema#",
                },
            }), target.constructor);
        };
    }
    static ApiPostMethod(route, responseCodes, returnType) {
        return (target, propertyKey, descriptor) => {
            ManagedApiInternal_1.ManagedApiInternal.AddApiMetadataToObject(ApiMethodDecorators.wrapApiMethod("POST" /* ApiMethod.POST */, route, propertyKey, descriptor, responseCodes, returnType), target.constructor);
        };
    }
    static ApiPutMethod(route, responseCodes, returnType) {
        return (target, propertyKey, descriptor) => {
            ManagedApiInternal_1.ManagedApiInternal.AddApiMetadataToObject(ApiMethodDecorators.wrapApiMethod("PUT" /* ApiMethod.PUT */, route, propertyKey, descriptor, responseCodes, returnType), target.constructor);
        };
    }
    static ApiDeleteMethod(route, responseCodes, returnType) {
        return (target, propertyKey, descriptor) => {
            ManagedApiInternal_1.ManagedApiInternal.AddApiMetadataToObject(ApiMethodDecorators.wrapApiMethod("DELETE" /* ApiMethod.DELETE */, route, propertyKey, descriptor, responseCodes, returnType), target.constructor);
        };
    }
    static wrapApiMethod(method, route, handlerKey, descriptor, responseCodes, returnType) {
        return this.wrapApiMethodWithHandler(method, route, handlerKey, descriptor.value, responseCodes, returnType);
    }
    static wrapApiMethodWithHandler(method, route, handlerKey, handler, responseCodes, returnType) {
        return {
            method,
            route,
            handlerKey,
            handler,
            returnType,
            responseCodes: ApiMethodDecorators.toResponseCodesArray(responseCodes),
        };
    }
    static toResponseCodesArray(responseCodes) {
        if (typeof responseCodes === 'number') {
            return [responseCodes];
        }
        if (!responseCodes || !Array.isArray(responseCodes) || responseCodes.length === 0) {
            return [Constants_1.DefaultApiResponseCode];
        }
        return responseCodes;
    }
}
__decorate([
    (0, DecoratorUtil_1.ApiDecorator)(HandlerMethodDecorator_1.HandlerMethodDecorator, {
        indexTs: __filename,
        dependencies: [(0, DecoratorUtil_1.DecoratorParentNameDependency)(exports.Api.name)],
        provider: TransformerMetadata_1.BuiltinMetadata.BuiltinComponent,
        arguments: [
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.RouteArgument,
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.ResponseCodesArgument,
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.ReturnSchemaArgument,
        ],
        metadata: [
            TransformerMetadata_1.BuiltinMetadata.ApiMethodWithValue("GET" /* ApiMethod.GET */),
            TransformerMetadata_1.BuiltinMetadata.ApiMethodTypeHttp,
        ],
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Array, Object]),
    __metadata("design:returntype", Function)
], ApiMethodDecorators, "ApiGetMethod", null);
__decorate([
    (0, DecoratorUtil_1.ApiDecorator)(HandlerMethodDecorator_1.HandlerMethodDecorator, {
        indexTs: __filename,
        dependencies: [(0, DecoratorUtil_1.DecoratorParentNameDependency)(exports.Api.name)],
        provider: TransformerMetadata_1.BuiltinMetadata.BuiltinComponent,
        arguments: [
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.RouteArgument,
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.DecoratorTypeArgTypeArgument(0),
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.SchemaOutputRefOverrideArgument,
        ],
        metadata: [
            TransformerMetadata_1.BuiltinMetadata.ApiMethodWithValue("GET" /* ApiMethod.GET */),
            TransformerMetadata_1.BuiltinMetadata.ApiMethodTypeHttp,
            TransformerMetadata_1.BuiltinMetadata.GetSchemaReturnSchema,
        ],
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Object]),
    __metadata("design:returntype", Function)
], ApiMethodDecorators, "ApiGetSchemaMethod", null);
__decorate([
    (0, DecoratorUtil_1.ApiDecorator)(HandlerMethodDecorator_1.HandlerMethodDecorator, {
        indexTs: __filename,
        dependencies: [(0, DecoratorUtil_1.DecoratorParentNameDependency)(exports.Api.name)],
        provider: TransformerMetadata_1.BuiltinMetadata.BuiltinComponent,
        arguments: [
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.RouteArgument,
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.ResponseCodesArgument,
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.ReturnSchemaArgument,
        ],
        metadata: [
            TransformerMetadata_1.BuiltinMetadata.ApiMethodWithValue("POST" /* ApiMethod.POST */),
            TransformerMetadata_1.BuiltinMetadata.ApiMethodTypeHttp,
        ],
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Array, Object]),
    __metadata("design:returntype", void 0)
], ApiMethodDecorators, "ApiPostMethod", null);
__decorate([
    (0, DecoratorUtil_1.ApiDecorator)(HandlerMethodDecorator_1.HandlerMethodDecorator, {
        indexTs: __filename,
        dependencies: [(0, DecoratorUtil_1.DecoratorParentNameDependency)(exports.Api.name)],
        provider: TransformerMetadata_1.BuiltinMetadata.BuiltinComponent,
        arguments: [
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.RouteArgument,
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.ResponseCodesArgument,
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.ReturnSchemaArgument,
        ],
        metadata: [
            TransformerMetadata_1.BuiltinMetadata.ApiMethodWithValue("PUT" /* ApiMethod.PUT */),
            TransformerMetadata_1.BuiltinMetadata.ApiMethodTypeHttp,
        ],
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Array, Object]),
    __metadata("design:returntype", void 0)
], ApiMethodDecorators, "ApiPutMethod", null);
__decorate([
    (0, DecoratorUtil_1.ApiDecorator)(HandlerMethodDecorator_1.HandlerMethodDecorator, {
        indexTs: __filename,
        dependencies: [(0, DecoratorUtil_1.DecoratorParentNameDependency)(exports.Api.name)],
        provider: TransformerMetadata_1.BuiltinMetadata.BuiltinComponent,
        arguments: [
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.RouteArgument,
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.ResponseCodesArgument,
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.ReturnSchemaArgument,
        ],
        metadata: [
            TransformerMetadata_1.BuiltinMetadata.ApiMethodWithValue("DELETE" /* ApiMethod.DELETE */),
            TransformerMetadata_1.BuiltinMetadata.ApiMethodTypeHttp,
        ],
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Array, Object]),
    __metadata("design:returntype", void 0)
], ApiMethodDecorators, "ApiDeleteMethod", null);
exports.GetApiDecorator = (0, DecoratorUtil_1.ApiMethodDecoratorGetFunction)(ApiClassDecorators);
exports.GetApiMethodDecorator = (0, DecoratorUtil_1.ApiMethodDecoratorGetFunction)(ApiMethodDecorators);
exports.ApiGetMethod = ApiMethodDecorators.ApiGetMethod;
exports.ApiPutMethod = ApiMethodDecorators.ApiPutMethod;
exports.ApiPostMethod = ApiMethodDecorators.ApiPostMethod;
exports.ApiDeleteMethod = ApiMethodDecorators.ApiDeleteMethod;
exports.ApiGetSchemaMethod = ApiMethodDecorators.ApiGetSchemaMethod;
//# sourceMappingURL=API.js.map