import 'reflect-metadata';
import { HandlerMethodDecorator } from "../transformer/HandlerMethodDecorator";
import { ApiProcessorTime, IApiPreProcessor, IApiPostProcessor, ApiProcessorScope } from '../apiManagement/ApiProcessing/ApiProcessing';
export type ApiMethodDecoratorReturnType<T, K = (...args: any[]) => T> = (target: object, propertyKey: string, descriptor: TypedPropertyDescriptor<K>) => void;
declare abstract class ApiProcessingDecorators {
    static ApiProcessor(stage: ApiProcessorTime.StagePreInvoke, scope?: ApiProcessorScope): ApiMethodDecoratorReturnType<never, IApiPreProcessor['processor']>;
    static ApiProcessor(stage: ApiProcessorTime.StagePostInvoke, scope?: ApiProcessorScope): ApiMethodDecoratorReturnType<never, IApiPostProcessor['processor']>;
}
export declare const GetApiProcessorDecorator: (param: string | Function) => HandlerMethodDecorator;
export declare const ApiProcessor: typeof ApiProcessingDecorators.ApiProcessor;
export {};
