"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApiProcessor = exports.GetApiProcessorDecorator = void 0;
require("reflect-metadata");
const ManagedApiInternal_1 = require("../apiManagement/ManagedApiInternal");
const DecoratorUtil_1 = require("./DecoratorUtil");
const HandlerMethodDecorator_1 = require("../transformer/HandlerMethodDecorator");
const TransformerMetadata_1 = require("../transformer/TransformerMetadata");
const BuiltinArgumentExtractors_1 = require("../transformer/BuiltinArgumentExtractors");
const ApiProcessing_1 = require("../apiManagement/ApiProcessing/ApiProcessing");
const API_1 = require("./API");
class ApiProcessingDecorators {
    static ApiProcessor(stage, scope = ApiProcessing_1.ApiProcessorScope.ScopeGlobal) {
        return (target, propertyKey, descriptor) => {
            ManagedApiInternal_1.ManagedApiInternal.AddGlobalApiProcessorMetadataToObject({
                stage,
                scope,
                handlerKey: propertyKey,
                handler: descriptor.value,
            }, target.constructor);
        };
    }
}
__decorate([
    (0, DecoratorUtil_1.ApiDecorator)(HandlerMethodDecorator_1.HandlerMethodDecorator, {
        indexTs: __filename,
        dependencies: [(0, DecoratorUtil_1.DecoratorParentNameDependency)(API_1.Api.name)],
        provider: TransformerMetadata_1.BuiltinMetadata.BuiltinComponent,
        arguments: [
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.ApiProcessorStageArgument,
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.ApiProcessorScopeArgument,
        ],
        metadata: [],
        transformArgumentsToObject: false,
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String]),
    __metadata("design:returntype", Function)
], ApiProcessingDecorators, "ApiProcessor", null);
exports.GetApiProcessorDecorator = (0, DecoratorUtil_1.ApiMethodDecoratorGetFunction)(ApiProcessingDecorators);
exports.ApiProcessor = ApiProcessingDecorators.ApiProcessor;
//# sourceMappingURL=ApiProcessing.js.map