"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApiBodyParamRawString = exports.ApiBodyParamStream = exports.ApiBodyParamNumber = exports.ApiBodyParamString = exports.ApiBodyParam = exports.GetBodyParamDecorator = void 0;
const apiManagement_1 = require("../apiManagement");
const InternalTypes_1 = require("../apiManagement/InternalTypes");
const DecoratorUtil_1 = require("./DecoratorUtil");
const HandlerMethodParameterDecorator_1 = require("../transformer/HandlerMethodParameterDecorator");
const BuiltinArgumentExtractors_1 = require("../transformer/BuiltinArgumentExtractors");
const TransformerMetadata_1 = require("../transformer/TransformerMetadata");
const API_1 = require("./API");
class BodyParams {
    static ApiBodyParamString(a) {
        return BodyParams.ApiBodyParam(a);
    }
    static ApiBodyParamNumber(a) {
        return BodyParams.ApiBodyParam(a);
    }
    static ApiBodyParamStream(a) {
        const args = a;
        return (target, propertyKey, parameterIndex) => {
            apiManagement_1.ManagedApiInternal.AddApiHandlerParamMetadataToObject({
                ...a,
                args,
                parameterIndex,
                propertyKey,
                type: 1 /* ApiParamType.RawBody */,
                bodyType: 0 /* ApiRawBodyParamType.Stream */,
            }, target.constructor);
        };
    }
    static ApiBodyParamMultipartFormFileName(a) {
        const args = a;
        return (target, propertyKey, parameterIndex) => {
            apiManagement_1.ManagedApiInternal.AddApiHandlerParamMetadataToObject({
                ...a,
                args,
                parameterIndex,
                propertyKey,
                type: 0 /* ApiParamType.Body */,
                bodyType: 0 /* ApiRawBodyParamType.Stream */,
            }, target.constructor);
        };
    }
    static ApiBodyParamMultipartFormFileString(a) {
        const args = a;
        return (target, propertyKey, parameterIndex) => {
            apiManagement_1.ManagedApiInternal.AddApiHandlerParamMetadataToObject({
                ...a,
                args,
                parameterIndex,
                propertyKey,
                type: 0 /* ApiParamType.Body */,
                bodyType: 1 /* ApiRawBodyParamType.String */,
            }, target.constructor);
        };
    }
    static ApiBodyParamMultipartFormFileStream(a) {
        const args = a;
        return (target, propertyKey, parameterIndex) => {
            apiManagement_1.ManagedApiInternal.AddApiHandlerParamMetadataToObject({
                ...a,
                args,
                parameterIndex,
                propertyKey,
                type: 0 /* ApiParamType.Body */,
                bodyType: 0 /* ApiRawBodyParamType.Stream */,
            }, target.constructor);
        };
    }
    static ApiBodyParamRawString(a) {
        const args = a;
        return (target, propertyKey, parameterIndex) => {
            apiManagement_1.ManagedApiInternal.AddApiHandlerParamMetadataToObject({
                ...a,
                args,
                parameterIndex,
                propertyKey,
                type: 1 /* ApiParamType.RawBody */,
                bodyType: 1 /* ApiRawBodyParamType.String */,
            }, target.constructor);
        };
    }
    static ApiBodyParam(a) {
        const args = a;
        return (target, propertyKey, parameterIndex) => {
            apiManagement_1.ManagedApiInternal.AddApiHandlerParamMetadataToObject({
                args,
                parameterIndex,
                propertyKey,
                type: 0 /* ApiParamType.Body */,
            }, target.constructor);
        };
    }
}
__decorate([
    (0, DecoratorUtil_1.ApiDecorator)(HandlerMethodParameterDecorator_1.HandlerMethodParameterDecorator, {
        indexTs: __filename,
        dependencies: [(0, DecoratorUtil_1.DecoratorParentNameDependency)(API_1.Api.name)],
        parameterType: 0 /* ApiParamType.Body */,
        parameterTypeRestrictions: [InternalTypes_1.InternalTypeUtil.TypeString],
        provider: TransformerMetadata_1.BuiltinMetadata.BuiltinComponent,
        transformArgumentsToObject: true,
        arguments: [
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.RegexpArgument,
        ],
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], BodyParams, "ApiBodyParamString", null);
__decorate([
    (0, DecoratorUtil_1.ApiDecorator)(HandlerMethodParameterDecorator_1.HandlerMethodParameterDecorator, {
        indexTs: __filename,
        dependencies: [(0, DecoratorUtil_1.DecoratorParentNameDependency)(API_1.Api.name)],
        parameterType: 0 /* ApiParamType.Body */,
        parameterTypeRestrictions: [InternalTypes_1.InternalTypeUtil.TypeNumber],
        provider: TransformerMetadata_1.BuiltinMetadata.BuiltinComponent,
        transformArgumentsToObject: true,
        arguments: [
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.NumberMinArgument,
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.NumberMaxArgument,
        ],
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], BodyParams, "ApiBodyParamNumber", null);
__decorate([
    (0, DecoratorUtil_1.ApiDecorator)(HandlerMethodParameterDecorator_1.HandlerMethodParameterDecorator, {
        indexTs: __filename,
        dependencies: [(0, DecoratorUtil_1.DecoratorParentNameDependency)(API_1.Api.name)],
        parameterType: 1 /* ApiParamType.RawBody */,
        parameterTypeRestrictions: [InternalTypes_1.InternalTypeUtil.TypeAnyObject],
        provider: TransformerMetadata_1.BuiltinMetadata.BuiltinComponent,
        transformArgumentsToObject: true,
        skipOutputTypeDefinitions: true,
        arguments: [
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.OptionalMimeTypeArgument,
        ],
        metadata: [
            {
                ...TransformerMetadata_1.BuiltinMetadata.SchemaFormat,
                value: 'binary',
            }
        ],
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], BodyParams, "ApiBodyParamStream", null);
__decorate([
    (0, DecoratorUtil_1.ApiDecorator)(HandlerMethodParameterDecorator_1.HandlerMethodParameterDecorator, {
        indexTs: __filename,
        dependencies: [(0, DecoratorUtil_1.DecoratorParentNameDependency)(API_1.Api.name)],
        parameterType: 10 /* ApiParamType.FormFileSingle */,
        parameterTypeRestrictions: [InternalTypes_1.InternalTypeUtil.TypeString],
        provider: TransformerMetadata_1.BuiltinMetadata.BuiltinComponent,
        transformArgumentsToObject: true,
        skipOutputTypeDefinitions: true,
        arguments: [
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.RegexpArgument,
        ],
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], BodyParams, "ApiBodyParamMultipartFormFileName", null);
__decorate([
    (0, DecoratorUtil_1.ApiDecorator)(HandlerMethodParameterDecorator_1.HandlerMethodParameterDecorator, {
        indexTs: __filename,
        dependencies: [(0, DecoratorUtil_1.DecoratorParentNameDependency)(API_1.Api.name)],
        parameterType: 10 /* ApiParamType.FormFileSingle */,
        parameterTypeRestrictions: [InternalTypes_1.InternalTypeUtil.TypeString],
        provider: TransformerMetadata_1.BuiltinMetadata.BuiltinComponent,
        transformArgumentsToObject: true,
        arguments: [
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.OptionalMimeTypeArgument,
        ],
        metadata: [
            {
                ...TransformerMetadata_1.BuiltinMetadata.FormDataFieldName,
                value: 'fileName',
            },
            {
                ...TransformerMetadata_1.BuiltinMetadata.SchemaFormat,
                value: 'binary',
            },
        ],
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], BodyParams, "ApiBodyParamMultipartFormFileString", null);
__decorate([
    (0, DecoratorUtil_1.ApiDecorator)(HandlerMethodParameterDecorator_1.HandlerMethodParameterDecorator, {
        indexTs: __filename,
        dependencies: [(0, DecoratorUtil_1.DecoratorParentNameDependency)(API_1.Api.name)],
        parameterType: 10 /* ApiParamType.FormFileSingle */,
        parameterTypeRestrictions: [InternalTypes_1.InternalTypeUtil.TypeAnyObject],
        provider: TransformerMetadata_1.BuiltinMetadata.BuiltinComponent,
        transformArgumentsToObject: true,
        arguments: [
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.OptionalMimeTypeArgument,
        ],
        metadata: [
            {
                ...TransformerMetadata_1.BuiltinMetadata.FormDataFieldName,
                value: 'fileName',
            },
            {
                ...TransformerMetadata_1.BuiltinMetadata.SchemaFormat,
                value: 'binary',
            },
        ],
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], BodyParams, "ApiBodyParamMultipartFormFileStream", null);
__decorate([
    (0, DecoratorUtil_1.ApiDecorator)(HandlerMethodParameterDecorator_1.HandlerMethodParameterDecorator, {
        indexTs: __filename,
        dependencies: [(0, DecoratorUtil_1.DecoratorParentNameDependency)(API_1.Api.name)],
        parameterType: 1 /* ApiParamType.RawBody */,
        parameterTypeRestrictions: [InternalTypes_1.InternalTypeUtil.TypeString],
        provider: TransformerMetadata_1.BuiltinMetadata.BuiltinComponent,
        transformArgumentsToObject: true,
        skipOutputTypeDefinitions: true,
        arguments: [
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.OptionalMimeTypeArgument,
        ],
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], BodyParams, "ApiBodyParamRawString", null);
__decorate([
    (0, DecoratorUtil_1.ApiDecorator)(HandlerMethodParameterDecorator_1.HandlerMethodParameterDecorator, {
        indexTs: __filename,
        dependencies: [(0, DecoratorUtil_1.DecoratorParentNameDependency)(API_1.Api.name)],
        parameterType: 0 /* ApiParamType.Body */,
        parameterTypeRestrictions: [
            InternalTypes_1.InternalTypeUtil.TypeNumber,
            InternalTypes_1.InternalTypeUtil.TypeString,
            InternalTypes_1.InternalTypeUtil.TypeDate,
            InternalTypes_1.InternalTypeUtil.TypeAnyObject,
            InternalTypes_1.InternalTypeUtil.TypeAnyArray,
            InternalTypes_1.InternalTypeUtil.TypeAny,
        ],
        provider: TransformerMetadata_1.BuiltinMetadata.BuiltinComponent,
        transformArgumentsToObject: true,
        arguments: [
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.ValidationFunctionArgument,
        ],
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Function)
], BodyParams, "ApiBodyParam", null);
exports.GetBodyParamDecorator = (0, DecoratorUtil_1.ApiMethodDecoratorGetFunction)(BodyParams);
exports.ApiBodyParam = BodyParams.ApiBodyParam;
exports.ApiBodyParamString = BodyParams.ApiBodyParamString;
exports.ApiBodyParamNumber = BodyParams.ApiBodyParamNumber;
exports.ApiBodyParamStream = BodyParams.ApiBodyParamStream;
exports.ApiBodyParamRawString = BodyParams.ApiBodyParamRawString;
// export const ApiBodyParamMultipartFormFileName = BodyParams.ApiBodyParamMultipartFormFileName;
// export const ApiBodyParamMultipartFormFileString = BodyParams.ApiBodyParamMultipartFormFileString;
// export const ApiBodyParamMultipartFormFileStream = BodyParams.ApiBodyParamMultipartFormFileStream;
//# sourceMappingURL=BodyParams.js.map