"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DecoratorPeerDependency = exports.DecoratorParentProviderDependency = exports.DecoratorParentNameDependency = exports.DecoratorParentDependency = exports.ApiMethodDecoratorGetFunction = exports.ApiDecorator = void 0;
const DecoratorDefinition_1 = require("../transformer/DecoratorDefinition");
const apiDecoratorKey = 'apidecorator';
function ApiDecorator(c, d) {
    return (target, propertyKey, descriptor) => {
        descriptor.writable = false;
        descriptor.configurable = false;
        Reflect.defineMetadata(apiDecoratorKey, new c({
            ...d,
            magicFunctionName: propertyKey,
        }), target, propertyKey);
    };
}
exports.ApiDecorator = ApiDecorator;
function ApiMethodDecoratorGetFunction(baseClass) {
    return (param) => {
        return Reflect.getMetadata(apiDecoratorKey, baseClass, typeof param === 'function' ? param.name : param);
    };
}
exports.ApiMethodDecoratorGetFunction = ApiMethodDecoratorGetFunction;
function DecoratorParentDependency(type, value) {
    return {
        type,
        dependency: value,
        location: DecoratorDefinition_1.DecoratorDependencyLocation.Parent,
    };
}
exports.DecoratorParentDependency = DecoratorParentDependency;
function DecoratorParentNameDependency(value) {
    return {
        type: DecoratorDefinition_1.DecoratorDependencyType.NameDependency,
        dependency: value,
        location: DecoratorDefinition_1.DecoratorDependencyLocation.Parent,
    };
}
exports.DecoratorParentNameDependency = DecoratorParentNameDependency;
function DecoratorParentProviderDependency(value) {
    return {
        type: DecoratorDefinition_1.DecoratorDependencyType.ProviderDependency,
        dependency: value,
        location: DecoratorDefinition_1.DecoratorDependencyLocation.Parent,
    };
}
exports.DecoratorParentProviderDependency = DecoratorParentProviderDependency;
function DecoratorPeerDependency(type, value) {
    return {
        type,
        dependency: value,
        location: DecoratorDefinition_1.DecoratorDependencyLocation.Peer,
    };
}
exports.DecoratorPeerDependency = DecoratorPeerDependency;
//# sourceMappingURL=DecoratorUtil.js.map