"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApiInjectedDependencyParam = exports.ApiInjectedDependency = exports.ApiDependency = exports.GetDependencyParamDecorator = void 0;
const apiManagement_1 = require("../apiManagement");
const DecoratorUtil_1 = require("./DecoratorUtil");
const TransformerMetadata_1 = require("../transformer/TransformerMetadata");
const HandlerMethodParameterDecorator_1 = require("../transformer/HandlerMethodParameterDecorator");
const BuiltinArgumentExtractors_1 = require("../transformer/BuiltinArgumentExtractors");
const ClassPropertyDecorator_1 = require("../transformer/ClassPropertyDecorator");
const DependencyClassDecorator_1 = require("../transformer/DependencyClassDecorator");
class DependencyParams {
    static ApiDependency(constructor) {
        apiManagement_1.ManagedApiInternal.RegisterApi(constructor);
    }
    static ApiInjectedDependency(a) {
        const args = a;
        return (target, propertyKey) => {
            apiManagement_1.ManagedApiInternal.AddDependencyMetadataToObject({
                propertyKey,
                dependency: args.typeref ? args.typeref : args.typedef,
                requirementTime: "use" /* DependencyInitializationTime.OnUse */,
            }, target.constructor);
        };
    }
    static ApiInjectedDependencyParam(a) {
        const args = a;
        return (target, propertyKey, parameterIndex) => {
            if (propertyKey) {
                apiManagement_1.ManagedApiInternal.AddApiDependencyParamMetadataToObject({
                    parameterIndex,
                    propertyKey,
                    dependency: args.typeref ? args.typeref : args.typedef,
                    requirementTime: propertyKey === DependencyParams.ConstructorKey
                        ? "constr" /* DependencyInitializationTime.OnConstruction */
                        : "use" /* DependencyInitializationTime.OnUse */,
                }, target.constructor);
                apiManagement_1.ManagedApiInternal.AddApiHandlerParamMetadataToObject({
                    args,
                    parameterIndex,
                    propertyKey,
                    type: 7 /* ApiParamType.Dependency */,
                }, target.constructor);
            }
            else {
                apiManagement_1.ManagedApiInternal.AddApiDependencyParamMetadataToObject({
                    parameterIndex,
                    propertyKey,
                    dependency: args.typeref ? args.typeref : args.typedef,
                    requirementTime: propertyKey === DependencyParams.ConstructorKey
                        ? "constr" /* DependencyInitializationTime.OnConstruction */
                        : "use" /* DependencyInitializationTime.OnUse */,
                }, target);
            }
        };
    }
}
DependencyParams.ConstructorKey = undefined;
__decorate([
    (0, DecoratorUtil_1.ApiDecorator)(DependencyClassDecorator_1.DependencyClassDecorator, {
        indexTs: __filename,
        dependencies: [],
        provider: TransformerMetadata_1.BuiltinMetadata.BuiltinComponent,
        arguments: [],
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [typeof (_a = typeof T !== "undefined" && T) === "function" ? _a : Object]),
    __metadata("design:returntype", void 0)
], DependencyParams, "ApiDependency", null);
__decorate([
    (0, DecoratorUtil_1.ApiDecorator)(ClassPropertyDecorator_1.ClassPropertyDecorator, {
        indexTs: __filename,
        dependencies: [],
        provider: TransformerMetadata_1.BuiltinMetadata.BuiltinComponent,
        transformArgumentsToObject: true,
        arguments: [
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.DependencyScopeArgument,
        ],
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Function)
], DependencyParams, "ApiInjectedDependency", null);
__decorate([
    (0, DecoratorUtil_1.ApiDecorator)(HandlerMethodParameterDecorator_1.HandlerMethodParameterDecorator, {
        indexTs: __filename,
        dependencies: [],
        parameterType: 7 /* ApiParamType.Dependency */,
        provider: TransformerMetadata_1.BuiltinMetadata.BuiltinComponent,
        transformArgumentsToObject: true,
        arguments: [
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.DependencyScopeArgument,
        ],
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Function)
], DependencyParams, "ApiInjectedDependencyParam", null);
exports.GetDependencyParamDecorator = (0, DecoratorUtil_1.ApiMethodDecoratorGetFunction)(DependencyParams);
exports.ApiDependency = DependencyParams.ApiDependency;
exports.ApiInjectedDependency = DependencyParams.ApiInjectedDependency;
exports.ApiInjectedDependencyParam = DependencyParams.ApiInjectedDependencyParam;
//# sourceMappingURL=DependencyParams.js.map