"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApiHeaderParamNumber = exports.ApiHeaderParamString = exports.ApiHeaderParam = exports.GetHeaderParamDecorator = void 0;
const apiManagement_1 = require("../apiManagement");
const InternalTypes_1 = require("../apiManagement/InternalTypes");
const DecoratorUtil_1 = require("./DecoratorUtil");
const API_1 = require("./API");
const TransformerMetadata_1 = require("../transformer/TransformerMetadata");
const BuiltinArgumentExtractors_1 = require("../transformer/BuiltinArgumentExtractors");
const HandlerMethodParameterDecorator_1 = require("../transformer/HandlerMethodParameterDecorator");
class HeaderParams {
    static ApiHeaderParamString(a) {
        return HeaderParams.ApiHeaderParam(a);
    }
    static ApiHeaderParamNumber(a) {
        return HeaderParams.ApiHeaderParam(a);
    }
    static ApiHeaderParam(a) {
        const args = a;
        return (target, propertyKey, parameterIndex) => {
            apiManagement_1.ManagedApiInternal.AddApiHandlerParamMetadataToObject({
                args,
                parameterIndex,
                propertyKey,
                type: 4 /* ApiParamType.Header */,
            }, target.constructor);
        };
    }
}
__decorate([
    (0, DecoratorUtil_1.ApiDecorator)(HandlerMethodParameterDecorator_1.HandlerMethodParameterDecorator, {
        indexTs: __filename,
        dependencies: [(0, DecoratorUtil_1.DecoratorParentNameDependency)(API_1.Api.name)],
        parameterType: 4 /* ApiParamType.Header */,
        parameterTypeRestrictions: [InternalTypes_1.InternalTypeUtil.TypeString],
        provider: TransformerMetadata_1.BuiltinMetadata.BuiltinComponent,
        transformArgumentsToObject: true,
        arguments: [
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.OptionalNameArgument,
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.RegexpArgument,
        ],
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Function)
], HeaderParams, "ApiHeaderParamString", null);
__decorate([
    (0, DecoratorUtil_1.ApiDecorator)(HandlerMethodParameterDecorator_1.HandlerMethodParameterDecorator, {
        indexTs: __filename,
        dependencies: [(0, DecoratorUtil_1.DecoratorParentNameDependency)(API_1.Api.name)],
        parameterType: 4 /* ApiParamType.Header */,
        parameterTypeRestrictions: [InternalTypes_1.InternalTypeUtil.TypeNumber],
        provider: TransformerMetadata_1.BuiltinMetadata.BuiltinComponent,
        transformArgumentsToObject: true,
        arguments: [
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.OptionalNameArgument,
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.NumberMinArgument,
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.NumberMaxArgument,
        ],
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Function)
], HeaderParams, "ApiHeaderParamNumber", null);
__decorate([
    (0, DecoratorUtil_1.ApiDecorator)(HandlerMethodParameterDecorator_1.HandlerMethodParameterDecorator, {
        indexTs: __filename,
        dependencies: [(0, DecoratorUtil_1.DecoratorParentNameDependency)(API_1.Api.name)],
        parameterType: 4 /* ApiParamType.Header */,
        parameterTypeRestrictions: [
            InternalTypes_1.InternalTypeUtil.TypeNumber,
            InternalTypes_1.InternalTypeUtil.TypeString,
            InternalTypes_1.InternalTypeUtil.TypeDate,
            InternalTypes_1.InternalTypeUtil.TypeEnum,
        ],
        provider: TransformerMetadata_1.BuiltinMetadata.BuiltinComponent,
        transformArgumentsToObject: true,
        arguments: [
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.OptionalNameArgument,
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.ValidationFunctionArgument,
        ],
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Function)
], HeaderParams, "ApiHeaderParam", null);
exports.GetHeaderParamDecorator = (0, DecoratorUtil_1.ApiMethodDecoratorGetFunction)(HeaderParams);
exports.ApiHeaderParam = HeaderParams.ApiHeaderParam;
exports.ApiHeaderParamString = HeaderParams.ApiHeaderParamString;
exports.ApiHeaderParamNumber = HeaderParams.ApiHeaderParamNumber;
//# sourceMappingURL=HeaderParams.js.map