"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApiPathParamNumber = exports.ApiPathParamString = exports.ApiPathParam = exports.GetPathParamDecorator = void 0;
const apiManagement_1 = require("../apiManagement");
const InternalTypes_1 = require("../apiManagement/InternalTypes");
const HandlerMethodParameterDecorator_1 = require("../transformer/HandlerMethodParameterDecorator");
const DecoratorUtil_1 = require("./DecoratorUtil");
const TransformerMetadata_1 = require("../transformer/TransformerMetadata");
const BuiltinArgumentExtractors_1 = require("../transformer/BuiltinArgumentExtractors");
const API_1 = require("./API");
class PathParams {
    static ApiPathParamString(a) {
        return PathParams.ApiPathParam(a);
    }
    static ApiPathParamNumber(a) {
        return PathParams.ApiPathParam(a);
    }
    static ApiPathParam(a) {
        const args = a;
        return (target, propertyKey, parameterIndex) => {
            apiManagement_1.ManagedApiInternal.AddApiHandlerParamMetadataToObject({
                args,
                parameterIndex,
                propertyKey,
                type: 3 /* ApiParamType.Path */,
            }, target.constructor);
        };
    }
}
__decorate([
    (0, DecoratorUtil_1.ApiDecorator)(HandlerMethodParameterDecorator_1.HandlerMethodParameterDecorator, {
        indexTs: __filename,
        dependencies: [(0, DecoratorUtil_1.DecoratorParentNameDependency)(API_1.Api.name)],
        parameterType: 3 /* ApiParamType.Path */,
        parameterTypeRestrictions: [InternalTypes_1.InternalTypeUtil.TypeString],
        provider: TransformerMetadata_1.BuiltinMetadata.BuiltinComponent,
        transformArgumentsToObject: true,
        arguments: [
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.OptionalNameArgument,
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.RegexpArgument,
        ],
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Function)
], PathParams, "ApiPathParamString", null);
__decorate([
    (0, DecoratorUtil_1.ApiDecorator)(HandlerMethodParameterDecorator_1.HandlerMethodParameterDecorator, {
        indexTs: __filename,
        dependencies: [(0, DecoratorUtil_1.DecoratorParentNameDependency)(API_1.Api.name)],
        parameterType: 3 /* ApiParamType.Path */,
        parameterTypeRestrictions: [InternalTypes_1.InternalTypeUtil.TypeNumber],
        provider: TransformerMetadata_1.BuiltinMetadata.BuiltinComponent,
        transformArgumentsToObject: true,
        arguments: [
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.OptionalNameArgument,
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.NumberMinArgument,
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.NumberMaxArgument,
        ],
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Function)
], PathParams, "ApiPathParamNumber", null);
__decorate([
    (0, DecoratorUtil_1.ApiDecorator)(HandlerMethodParameterDecorator_1.HandlerMethodParameterDecorator, {
        indexTs: __filename,
        dependencies: [(0, DecoratorUtil_1.DecoratorParentNameDependency)(API_1.Api.name)],
        parameterType: 3 /* ApiParamType.Path */,
        parameterTypeRestrictions: [
            InternalTypes_1.InternalTypeUtil.TypeNumber,
            InternalTypes_1.InternalTypeUtil.TypeString,
            InternalTypes_1.InternalTypeUtil.TypeDate,
            InternalTypes_1.InternalTypeUtil.TypeBoolean,
            InternalTypes_1.InternalTypeUtil.TypeEnum,
        ],
        provider: TransformerMetadata_1.BuiltinMetadata.BuiltinComponent,
        transformArgumentsToObject: true,
        arguments: [
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.OptionalNameArgument,
            BuiltinArgumentExtractors_1.BuiltinArgumentExtractors.ValidationFunctionArgument,
        ],
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Function)
], PathParams, "ApiPathParam", null);
exports.GetPathParamDecorator = (0, DecoratorUtil_1.ApiMethodDecoratorGetFunction)(PathParams);
exports.ApiPathParam = PathParams.ApiPathParam;
exports.ApiPathParamString = PathParams.ApiPathParamString;
exports.ApiPathParamNumber = PathParams.ApiPathParamNumber;
//# sourceMappingURL=PathParams.js.map