"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MustacheFileGenerator = void 0;
const Mustache = require("mustache");
const fs = require("promise-fs");
class MustacheFileGenerator {
    constructor(templatePath, templateEncoding = 'utf8') {
        this.templatePath = templatePath;
        this.templateEncoding = templateEncoding;
    }
    async generate(options, partials, tags) {
        return Buffer.from(Mustache.render(await this.loadTemplate(), options, partials, tags));
    }
    async loadTemplate() {
        if (!this.template) {
            this.template = await fs.readFile(this.templatePath, { encoding: this.templateEncoding });
        }
        return this.template;
    }
}
exports.MustacheFileGenerator = MustacheFileGenerator;
//# sourceMappingURL=MustacheFileGenerator.js.map