import * as ts from 'typescript';
import { IClassDecoratorDefinition } from './DecoratorDefinition';
import { ITransformedTreeElement, HandlerTreeNodeType, IHandlerTreeNode } from './HandlerTree';
import { Decorator } from './Decorator';
import { ITransformContext } from './ITransformContext';
export declare class ClassDecorator extends Decorator<ts.ClassDeclaration, IClassDecoratorDefinition> implements IClassDecoratorDefinition {
    private treeNodeType;
    constructor(definition: Omit<IClassDecoratorDefinition, 'decoratorType'>, treeNodeType: HandlerTreeNodeType.HandlerCollection | HandlerTreeNodeType.Dependency);
    getDecoratorTreeElement(parent: IHandlerTreeNode | undefined, node: ts.ClassDeclaration, decorator: ts.Decorator, context: ITransformContext): ITransformedTreeElement<ts.Decorator>;
}
