"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClassDecorator = void 0;
const DecoratorDefinition_1 = require("./DecoratorDefinition");
const Decorator_1 = require("./Decorator");
class ClassDecorator extends Decorator_1.Decorator {
    constructor(definition, treeNodeType) {
        super({
            ...definition,
            decoratorType: DecoratorDefinition_1.DecoratorType.Class,
        }, Decorator_1.DecoratorNodeType.Class);
        this.treeNodeType = treeNodeType;
    }
    getDecoratorTreeElement(parent, node, decorator, context) {
        let argumentResult = this.applyArguments(node, decorator, context);
        const decoratorResponse = {
            transformedDecorator: argumentResult.decorator,
            decoratorTreeNode: {
                type: this.treeNodeType,
                decorator: this.definition,
                children: [],
                location: this.getNodeLocation(node),
                parent,
                metadata: argumentResult.metadata,
            }
        };
        decoratorResponse.decoratorTreeNode.metadata = decoratorResponse.decoratorTreeNode.metadata.concat(context.metadataManager.getApiMetadataForApiMethodCollection(decoratorResponse.decoratorTreeNode, node, this));
        return decoratorResponse;
    }
}
exports.ClassDecorator = ClassDecorator;
//# sourceMappingURL=ClassDecorator.js.map