import * as ts from 'typescript';
import { IClassPropertyDecoratorDefinition } from './DecoratorDefinition';
import { ITransformedTreeElement, IHandlerTreeNode } from './HandlerTree';
import { Decorator } from './Decorator';
import { ITransformContext } from './ITransformContext';
import { ITransformerMetadata } from './TransformerMetadata';
import { InternalTypeDefinition } from '../apiManagement/InternalTypes';
export declare class ClassPropertyDecorator extends Decorator<ts.PropertyDeclaration, IClassPropertyDecoratorDefinition> implements IClassPropertyDecoratorDefinition {
    constructor(definition: Omit<IClassPropertyDecoratorDefinition, 'decoratorType'>);
    get memberTypeRestrictions(): InternalTypeDefinition[];
    getDecoratorTreeElement(parent: IHandlerTreeNode | undefined, node: ts.PropertyDeclaration, decorator: ts.Decorator, context: ITransformContext): ITransformedTreeElement<ts.Decorator>;
    protected getDefaultMetadataGetters(): Generator<(node: ts.PropertyDeclaration, decorator: ts.Decorator, context: ITransformContext) => ITransformerMetadata, void, unknown>;
    private getNodeTyperefMetadata;
    private getNodeTypedefMetadata;
    private getNodeOptionalMetadata;
    private getNodeInitializerMetadata;
}
