"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DecoratorResolver = void 0;
const CollectionUtil_1 = require("../Util/CollectionUtil");
class DecoratorResolver {
    constructor(defaultDecorators) {
        this.nodeTypeMap = new Map();
        if (defaultDecorators) {
            for (const decorator of defaultDecorators) {
                this.addDecorator(decorator);
            }
        }
    }
    addDecorator(decorator) {
        CollectionUtil_1.CollectionUtil.addToMapSet(this.nodeTypeMap, decorator.nodeType, decorator);
    }
    addDecorators(decorators) {
        for (const decorator of decorators) {
            this.addDecorator(decorator);
        }
    }
    getDecoratorsForNodeType(type, parent) {
        return Array.from(CollectionUtil_1.CollectionUtil.iterateSet(this.nodeTypeMap, type) || []);
    }
}
exports.DecoratorResolver = DecoratorResolver;
//# sourceMappingURL=DecoratorResolver.js.map