"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HandlerMethodModifierDecorator = void 0;
const DecoratorDefinition_1 = require("./DecoratorDefinition");
const HandlerTree_1 = require("./HandlerTree");
const Decorator_1 = require("./Decorator");
class HandlerMethodModifierDecorator extends Decorator_1.Decorator {
    constructor(definition) {
        super({
            ...definition,
            decoratorType: DecoratorDefinition_1.DecoratorType.Method,
            treeHierarchyType: DecoratorDefinition_1.DecoratorNodeTreeHierarchyType.Modifier,
        }, Decorator_1.DecoratorNodeType.Method);
    }
    get returnTypeRestriction() {
        return this.definition.returnTypeRestrictions;
    }
    getDecoratorTreeElement(parent, node, decorator, context) {
        let argumentResult = this.applyArguments(node, decorator, context);
        const decoratorTreeNode = {
            type: HandlerTree_1.HandlerTreeNodeType.HandlerModifier,
            decorator: this.definition,
            children: [],
            parent,
            location: this.getNodeLocation(node),
            metadata: argumentResult.metadata,
        };
        return {
            decoratorTreeNode,
            transformedDecorator: argumentResult.decorator,
        };
    }
}
exports.HandlerMethodModifierDecorator = HandlerMethodModifierDecorator;
//# sourceMappingURL=HandlerMethodModifierDecorator.js.map