import * as ts from 'typescript';
import { IParameterDecoratorDefinition } from './DecoratorDefinition';
import { ITransformedTreeElement, IHandlerTreeNode } from './HandlerTree';
import { InternalTypeDefinition } from '../apiManagement/InternalTypes';
import { ITransformContext } from './ITransformContext';
import { ITransformerMetadata } from './TransformerMetadata';
import { Decorator } from './Decorator';
export declare class HandlerMethodParameterDecorator extends Decorator<ts.ParameterDeclaration, IParameterDecoratorDefinition> implements IParameterDecoratorDefinition {
    constructor(definition: Omit<IParameterDecoratorDefinition, 'decoratorType'>);
    get parameterTypeRestrictions(): InternalTypeDefinition[];
    get parameterType(): import("../apiManagement/ApiDefinition").ApiParamType;
    get transportTypeId(): string;
    get paramId(): string;
    get bodyType(): import("../apiManagement/ApiDefinition").ApiRawBodyParamType;
    get skipOutputTypeDefinitions(): boolean;
    get overrideOutput(): boolean;
    getDecoratorTreeElement(parent: IHandlerTreeNode | undefined, node: ts.ParameterDeclaration, decorator: ts.Decorator, context: ITransformContext): ITransformedTreeElement<ts.Decorator>;
    protected getDefaultMetadataGetters(): Generator<(node: ts.ParameterDeclaration, decorator: ts.Decorator, context: ITransformContext) => ITransformerMetadata, void, unknown>;
    private getNodeTyperefMetadata;
    private getNodeTypedefMetadata;
    private getNodeOptionalMetadata;
    private getNodeInitializerMetadata;
    private getNodeDescriptionMetadata;
    private getNodeParameterIndexMetadata;
    private getNodePropertyKeyMetadata;
    private getParameterName;
    private getParamDescription;
}
