import * as ts from 'typescript';
import { IMetadataManager } from "./MetadataManager";
import { ITransformerMetadata } from './TransformerMetadata';
import { IHandlerTreeNodeHandler, IHandlerTreeNodeHandlerCollection } from './HandlerTree';
export declare const enum OpenApiMetadataType {
    Summary = "summary",
    ResponseDescription = "response",
    Private = "private",
    Description = "description",
    Tag = "tag"
}
export declare class OpenApiMetadataExtractors {
    static readonly JsDocTagTag = "tags";
    private constructor();
    static RegisterMetadataExtractors(mm: IMetadataManager): void;
    static ExtractClassJsDocMetadata(method: IHandlerTreeNodeHandlerCollection, methodNode: ts.ClassDeclaration): ITransformerMetadata[];
    static ExtractMethodJsDocMetadata(method: IHandlerTreeNodeHandler, methodNode: ts.MethodDeclaration): ITransformerMetadata[];
    private static getFirstCommentLine;
    private static getJsDocTags;
    private static getJsDocCustomTags;
    private static jsdocTagString;
}
