import { ApiMethod } from "../apiManagement";
export declare const enum IMetadataType {
    OpenApi = "OpenApi",
    Builtin = "Builtin",
    Plugin = "Plugin"
}
export interface ITransformerMetadataCollection {
    metadata: ITransformerMetadata[];
}
export interface IMetadataDescriptor {
    type: IMetadataType;
    component?: string;
    key?: string;
}
export interface ITransformerMetadata extends IMetadataDescriptor {
    value: any;
}
export declare function getMetadata(metadata: ITransformerMetadata[], type: IMetadataType, component?: string, key?: string): ITransformerMetadata | undefined;
export declare function getMetadataValue<V = ITransformerMetadata['value']>(metadata: ITransformerMetadata[], type: IMetadataType, component?: string, key?: string): V | undefined;
export declare function getMetadataByDescriptor(metadata: ITransformerMetadata[], descriptor: IMetadataDescriptor): ITransformerMetadata | undefined;
export declare function getMetadataValueByDescriptor<V = ITransformerMetadata['value']>(metadata: ITransformerMetadata[], descriptor: IMetadataDescriptor): V | undefined;
export declare function getAllMetadata(metadata: ITransformerMetadata[], type: IMetadataType, component?: string, key?: string): ITransformerMetadata[];
export declare function getAllMetadataValues<V = ITransformerMetadata['value']>(metadata: ITransformerMetadata[], type: IMetadataType, component?: string, key?: string): V[];
export declare abstract class BuiltinMetadata {
    static readonly BuiltinComponent = "ts-api-decorators";
    static readonly ApiMethod: IMetadataDescriptor;
    static ApiMethodWithValue(value: ApiMethod): ITransformerMetadata;
    static readonly ApiMethodType: IMetadataDescriptor;
    static readonly ApiMethodTypeHttp: ITransformerMetadata;
    static readonly Name: IMetadataDescriptor;
    static readonly FunctionArgumentName: IMetadataDescriptor;
    static readonly SchemaRefOverride: IMetadataDescriptor;
    static readonly MimeType: IMetadataDescriptor;
    static readonly Route: IMetadataDescriptor;
    static readonly ResponseCodes: IMetadataDescriptor;
    static readonly ApiProcessorStage: IMetadataDescriptor;
    static readonly ApiProcessorScope: IMetadataDescriptor;
    static readonly DependencyScope: IMetadataDescriptor;
    static readonly NumberMin: IMetadataDescriptor;
    static readonly NumberMax: IMetadataDescriptor;
    static readonly UndefinedIfOmitted: IMetadataDescriptor;
    static readonly ValidationRegExp: IMetadataDescriptor;
    static readonly ReturnSchema: IMetadataDescriptor;
    static readonly GetSchemaReturnSchema: ITransformerMetadata;
    static readonly DecoratorTypeArgType: IMetadataDescriptor;
    static readonly ValidationFunction: IMetadataDescriptor;
    static readonly Typedef: IMetadataDescriptor;
    static readonly Typeref: IMetadataDescriptor;
    static readonly Optional: IMetadataDescriptor;
    static readonly Initializer: IMetadataDescriptor;
    static readonly Description: IMetadataDescriptor;
    static readonly ParameterIndex: IMetadataDescriptor;
    static readonly PropertyKey: IMetadataDescriptor;
    static readonly FormDataFieldName: IMetadataDescriptor;
    static readonly SchemaFormat: IMetadataDescriptor;
}
