import { IDecorator } from './Decorator';
export interface ITransformerOpts {
    /**
     * An array of relative paths to files which contain one or more decorators as a default export.
     */
    customDecorators?: string[];
}
export declare class TransformerOpts implements ITransformerOpts {
    readonly rootDir: string;
    private readonly rootConfig;
    static readonly TransformerOptsFile = "tsapiconfig.json";
    private static TsNodeRegistered;
    /**
     * Parses transformer options in the root directory, if present.
     * @param rootDir
     */
    static ParseTransformerOpts(rootDir: string): TransformerOpts;
    constructor(rootDir: string, rootConfig: ITransformerOpts);
    get customDecorators(): string[];
    loadCustomDecorators(): IDecorator[];
}
