"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isTypeWithSymbol = exports.isNamedDeclaration = exports.isNodeWithJsDoc = exports.isIntersectionType = exports.isNodeWithTypeArguments = exports.isParameterizedType = exports.isUnionType = exports.nodeHasElements = exports.isIntrinsicType = exports.isBuiltinSymbol = exports.isSymbolWithParent = exports.isSymbolWithId = exports.isNamedNode = void 0;
const ts = require("typescript");
function isNamedNode(n) {
    return typeof n.name !== 'undefined';
}
exports.isNamedNode = isNamedNode;
function isSymbolWithId(s) {
    return typeof s.id === 'number';
}
exports.isSymbolWithId = isSymbolWithId;
function isSymbolWithParent(s) {
    return typeof s.parent === 'object';
}
exports.isSymbolWithParent = isSymbolWithParent;
function isBuiltinSymbol(s) {
    return s.name === Buffer.name || s.name === Promise.name;
}
exports.isBuiltinSymbol = isBuiltinSymbol;
function isIntrinsicType(s) {
    return typeof s.intrinsicName === 'string';
}
exports.isIntrinsicType = isIntrinsicType;
function nodeHasElements(s) {
    return s && Array.isArray(s.elements);
}
exports.nodeHasElements = nodeHasElements;
function isUnionType(n, s) {
    if (n) {
        return ts.isUnionTypeNode(n);
    }
    return Array.isArray(s.types);
}
exports.isUnionType = isUnionType;
function isParameterizedType(t) {
    if (t) {
        return Array.isArray(t.resolvedTypeArguments);
    }
    return false;
}
exports.isParameterizedType = isParameterizedType;
function isNodeWithTypeArguments(n) {
    return !!n && Array.isArray(n.typeArguments);
}
exports.isNodeWithTypeArguments = isNodeWithTypeArguments;
function isIntersectionType(n, s) {
    if (n) {
        return ts.isIntersectionTypeNode(n);
    }
    return Array.isArray(s.types);
}
exports.isIntersectionType = isIntersectionType;
function isNodeWithJsDoc(n) {
    return Array.isArray(n.jsDoc);
}
exports.isNodeWithJsDoc = isNodeWithJsDoc;
function isNamedDeclaration(n) {
    return typeof n.name !== 'undefined';
}
exports.isNamedDeclaration = isNamedDeclaration;
function isTypeWithSymbol(t) {
    return typeof t.symbol === 'object';
}
exports.isTypeWithSymbol = isTypeWithSymbol;
//# sourceMappingURL=TransformerUtil.js.map