import * as ts from 'typescript';
import * as tjs from "typescript-json-schema";
import { InternalTypeDefinition, IJsonSchemaWithRefs } from '../apiManagement/InternalTypes';
export declare class TypeSerializer {
    protected readonly program: ts.Program;
    protected readonly generator: tjs.JsonSchemaGenerator;
    protected readonly typeChecker: ts.TypeChecker;
    private static readonly ReferencePreamble;
    constructor(program: ts.Program, generator: tjs.JsonSchemaGenerator, typeChecker: ts.TypeChecker);
    getInternalTypeRepresentation(node: ts.TypeNode | undefined, type: ts.Type): InternalTypeDefinition;
    private getUnionType;
    private getTypeForSymbolWithId;
    private reduceSchemaReferences;
    private getRefsRecursive;
    private getRefShortName;
    getReferencedTypeDefinition(reference: IJsonSchemaWithRefs): IJsonSchemaWithRefs;
    protected valueToLiteral(val: any): ts.Expression;
    objectToLiteral(val: object): ts.ObjectLiteralExpression;
    compileExpressionToNumericConstant(expression: ts.Expression): number;
    compileExpressionToBooleanConstant(expression: ts.Expression): boolean;
    compileExpressionToStringConstant(expression: ts.Expression): string;
    compileExpressionToArrayConstant(expression: ts.Expression): Array<number | boolean | string>;
    private arrayNodeToConstant;
    protected compileExpressionToConstant(expression: ts.Expression): string | number | boolean;
    protected compileTemplateSpan(span: ts.TemplateSpan): any;
    protected compileTemplateTextPart(part: ts.TemplateMiddle | ts.TemplateTail | ts.TemplateHead): string;
}
